Last Comment Bug 495897 - "Assertion failure: !ti->typeMap.matches(ti_other->typeMap)" with undeclared global
: "Assertion failure: !ti->typeMap.matches(ti_other->typeMap)" with undeclared ...
Status: VERIFIED FIXED
fixed-in-tracemonkey
: assertion, fixed1.9.1, regression, testcase
Product: Core
Classification: Components
Component: JavaScript Engine (show other bugs)
: Trunk
: x86 Mac OS X
-- critical (vote)
: ---
Assigned To: Andreas Gal :gal
:
: Jason Orendorff [:jorendorff]
Mentors:
Depends on:
Blocks: js-differential-test 489682
  Show dependency treegraph
 
Reported: 2009-06-01 18:58 PDT by Jesse Ruderman
Modified: 2009-10-14 17:54 PDT (History)
11 users (show)
sayrer: blocking1.9.1+
mozaakash: in‑testsuite+
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
patch (5.80 KB, patch)
2009-06-02 17:32 PDT, Andreas Gal :gal
no flags Details | Diff | Splinter Review
add additional assert and test case (7.12 KB, patch)
2009-06-02 17:42 PDT, Andreas Gal :gal
dvander: review+
Details | Diff | Splinter Review

Description User image Jesse Ruderman 2009-06-01 18:58:09 PDT
// b must be undeclared global?
var E = "";
for each (var a in [E, E, 0/0, E]) {
    ++a;
    for each (b in [a, E, a, E, a, E, 0/0]) {
    }
}

Assertion failure: !ti->typeMap.matches(ti_other->typeMap), at ../jstracer.cpp:3780
Comment 1 User image Gary Kwong [:gkw] [:nth10sd] 2009-06-01 22:28:42 PDT
autoBisect shows this is probably related to bug 489682 :

The first bad revision is:
changeset:   28050:9d7ca9e8c8a5
user:        danderson
date:        Thu May 07 12:16:12 2009 -0700
summary:     Partial typemap in loop exit can lead to maltyped nested trees (489682, r=gal).
Comment 2 User image Andreas Gal :gal 2009-06-02 00:14:12 PDT
this has danderson or me all over it
Comment 3 User image Andreas Gal :gal 2009-06-02 17:32:09 PDT
Created attachment 381193 [details] [diff] [review]
patch

Make sure to mark slots a tree grew later are also marked as undemotable when stablizing a tree.
Comment 4 User image Andreas Gal :gal 2009-06-02 17:42:48 PDT
Created attachment 381195 [details] [diff] [review]
add additional assert and test case
Comment 8 User image Bob Clary [:bc:] 2009-10-14 17:54:12 PDT
v 1.9.3, 1.9.2

Note You need to log in before you can comment on or make changes to this bug.